#include "spawn.h"

#include "..\algorithms.h"

#include "..\dllcore.cpp"
#include "..\datatypes.cpp"
#include "..\algorithms.cpp"
#include "..\player.cpp"
#include "..\commtypes.cpp"

#define UNASSIGNED 0xffff


//////// Bot list ////////

_linkedlist <botInfo> botlist;

botInfo *findBot(CALL_HANDLE handle)
{
	_listnode <botInfo> *parse = botlist.head;

	while (parse)
	{
		botInfo *item = parse->item;

		if (item->validate(handle))
			return item;

		parse = parse->next;
	}

	return 0;
}

///////////MY CODE////////////

PlayerTag* botInfo::ReturnTag(Player *p)//given a player, it returns thier tag
{
	_listnode <PlayerTag> *pt= taglist.head; //holds all the player's tags

	while(pt)
	{
		if(stricmp(pt->item->name,p->name) == 0) //if the names of the tag and the player matches
		{break;} 
		pt= pt->next;//next tag
	}
	return pt->item;//return the player
}

Player* botInfo::ReturnPlayer(PlayerTag *pt)//given a tag, it returns the player
{
	_listnode <Player> *pl= playerlist->head; //get the playerlist

	while(pl)
	{
		if(stricmp(pl->item->name,pt->name) == 0) //if the tag name matches the player
		{break;}
		pl= pl->next;//next player
	}
	return pl->item;//return the player
}

void botInfo::RemoveInsidePerson(PlayerTag *pt, unsigned short *title) //Removes a player from inside title
{
	if(CheckInside(pt)) //make sure player is inside
	{
		_listnode <unsigned short> *AreaNumber=pt->AreaNumber.head; //holds all of the object numbers the player is over
		_listnode <Obj> *parseObj= parseObj= ObjLocations.head; // Holds All the obj locations
		String S; //sends mod commands
		
		while(AreaNumber) //Look through the areas the player is in
		{
			if(AreaNumber->item == title) //find the node the area number is in
			{break;}
			AreaNumber=AreaNumber->next;
		}
			
		pt->AreaNumber.kill(AreaNumber); //get rid of the node, player has left the area
	

		while (parseObj) //cycle through locations
		{
			if(*title == parseObj->item->title) //find the area that the player was in
			{break;}
			parseObj = parseObj->next;//go to next positions in list
		}

		if(parseObj->item->Private) //used for private obj switching, ON or OFF
		{
			if(parseObj->item->On_Off) //Player left the area, switch it back to its original state
			{
				S = "*objon "; //object on command
			}
			else
			{
				S="*objoff "; //object off command
			}
			S += parseObj->item->objNum; //add on object number
			sendPrivate(ReturnPlayer(pt),S.msg); //send command private, grabs player from their tag
		}
		else
		{
			if(!CheckAreaNumber(title)) // Checks to see if there are players inside area
			{				
				if(parseObj->item->On_Off) //switch its state becuase everyone left
				{
					S = "*objoff "; //object off command
					parseObj->item->On_Off=false;
				}
				else
				{
					S="*objon "; //object on command
					parseObj->item->On_Off=true;
				}

				S += parseObj->item->objNum; //add on object number
				sendPublic(S.msg); //send command public
			}
		}
	}
}

bool botInfo::CheckInside(PlayerTag *pt) //Check if the person is in a obj area
{
	return (pt->AreaNumber.total > 0); //if the player is in more than 0 object areas, then return true
}

bool botInfo::CheckAreaNumber(unsigned short *title) //Check for people in a specific obj area
{
	bool Inside=false; //return value

	_listnode <PlayerTag> *pt= taglist.head; //holds all the player's tags
	_listnode <unsigned short> *AreaNumber; //holds the areas the player is in

	while(pt) //look through taglist
	{
		AreaNumber=pt->item->AreaNumber.head; //set AreaNumber to the list of areas the player is inside
		while(AreaNumber)
		{
			if(AreaNumber->item == title) //if the area is already inhabited
			{
				Inside=true; //area occupied already. true
				break;
			}
			AreaNumber= AreaNumber->next;
		}
		if(Inside)
		{break;}
		pt = pt->next; //go to next player
	}

	return Inside; //return area inhabited or not inhabited
}

void botInfo::BotEnable() //Turns on objects that begin in the ON state
{
	String S; //send commands
	_listnode <Obj> *parseObj = ObjLocations.head; // Holds All the obj locations

	while(parseObj)
	{
		if(parseObj->item->On_Off) // Turn on a objects that start ON
		{
			S= "*objon "; //objon command
			S+= parseObj->item->objNum;// add its obj number
			sendPublic(S.msg); //send *objon signal
		}
		parseObj = parseObj->next; //go to next object to test it
	}
}

void botInfo::BotDisable() //Remove all players from inside area
{
	_listnode <PlayerTag> *pt= taglist.head; //taglist, pt=playertags
	_listnode <unsigned short> *AreaNumber; //holds the areas the players are inside
		
	while(pt)
	{
		AreaNumber=pt->item->AreaNumber.head;//set areanumber to the current player
		while(AreaNumber)
		{
			RemoveInsidePerson(pt->item,AreaNumber->item); //remove and turn objects back to original position
			AreaNumber= pt->item->AreaNumber.head;//once deleted AreaNumber, need to set it back to head pointer
		}
		pt->item->AreaNumber.clear();//make sure AreaNumber is clear and deallocated
		pt = pt->next; //next tag
	}
}

void botInfo::LoadObjAreas() //Load obj Areas from file
{
	char Path[512]; //File Path
	String title; //Obj's Title Number 
	GetCurrentDirectory(512, Path); //Grab Da Path
	strcat(Path, "\\objects.ini"); //concat with file

	char buffer[192];

	for (short i = 1; i < 256; i++) //cycle through areas
	{
		title = "Obj"; //Object number in file
		title += i;

#define G(name) ZeroMemory(buffer, 192);\
		GetPrivateProfileString(title.msg, name, "", buffer, 192, Path)

#define G2(a) if (isNumeric(buffer))\
			a = getInteger(buffer, 10);\
		else\
			goto InvalidEntry

		G("FromX1");
		if (!buffer[0]) //Didnt grab anything, then continue to next obj
			continue;

		Obj *w = new Obj; //new obj to place in linkedlist

		G2(w->x1);

		G("FromY1");
		G2(w->y1);

		G("FromX2");
		G2(w->x2);

		G("FromY2");
		G2(w->y2);
		#pragma warning(disable:4800) //Turns off warning message, it was pissing me off
		G("ObjStart");
		G2(bool(w->On_Off));

		G("SentPrivate");
		G2(bool(w->Private));
		#pragma warning(default:4800) //Turns warning back on

		G("ObjNum");
		G2(w->objNum);

		w->title=i; //title of the object, ex- [obj1]

		ObjLocations.append(w); //Place in list		

		continue;
InvalidEntry:
		String S; //Send error
		delete w;
		S = "Invalid objects.ini entry: ";
		S += i;
		tell(makeEcho(S.msg));
	}
}


//////// DLL "import" ////////

void botInfo::tell(BotEvent &event)
{
	if (callback && handle)
	{
		event.handle = handle;
		callback(event);
	}
}

void botInfo::gotEvent(BotEvent &event)
{
	if (CONNECTION_DENIED) return;

	switch (event.code)
	{
//////// Periodic ////////
	case EVENT_Tick:
		{
			for (int i = 0; i < 4; ++i)
				--countdown[i];
		}
		break;
//////// Arena ////////
	case EVENT_ArenaEnter:
		{
			arena = (char*)event.p[0];
			me = (Player*)event.p[1];	// if(me) {/*we are in the arena*/}
			bool biller_online = *(bool*)&event.p[2];
			BotEnable(); //Turn on objects that are in the ON state

			_listnode <Player> *pl= playerlist->head;
			while(pl) //player may already be in the arena, add them to taglist
			{
				PlayerTag *tag= new PlayerTag; //player, assign them a tag
				strcpy(tag->name,pl->item->name); //set the tag's name
				taglist.append(tag); //place on taglist

				pl=pl->next;
			}
		}
		break;
	case EVENT_ArenaSettings:
		{
			settings = (arenaSettings*)event.p[0];
			taglist.clear(); //In case of server recycle, clear all the players out of taglist
			ObjLocations.clear(); //In case of server recycle, need to clear linklist and reread file
			LoadObjAreas(); //Loads the obj areas from file	
		}
		break;
	case EVENT_ArenaLeave:
		{
			BotDisable(); //Disable bot, reset original state of objects
			taglist.clear(); //leaving arena, clear players
			ObjLocations.clear(); //leaving arena, clear objects
			me = 0;
		}
		break;
	case EVENT_ArenaListEntry:
		{
			char *name = (char*)event.p[0];
			bool current = *(bool*)&event.p[1];
			int population = *(int*)&event.p[2];
		}
		break;
	case EVENT_ArenaListEnd:
		{
			char *name = (char*)event.p[0];
			bool current = *(bool*)&event.p[1];
			int population = *(int*)&event.p[2];
		}
		break;
//////// Flag ////////
	case EVENT_FlagGrab:
		{
			Player *p = (Player*)event.p[0];
			Flag *f = (Flag*)event.p[1];
		}
		break;
	case EVENT_FlagDrop:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_FlagMove:
		{
			Flag *f = (Flag*)event.p[0];
		}
		break;
	case EVENT_FlagVictory:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
	case EVENT_FlagGameReset:
		{
		}
		break;
	case EVENT_FlagReward:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
//////// Timed ////////
	case EVENT_TimedGameOver:
		{
			Player *p[5];
			for (int i = 0; i < 5; i++)
				p[i] = (Player*)event.p[i];
		}
		break;
//////// Soccer ////////
	case EVENT_SoccerGoal:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
	case EVENT_BallMove:
		{
			PBall *ball = (PBall*)event.p[0];
		}
		break;
//////// File ////////
	case EVENT_File:
		{
			char *name = (char*)event.p[0];
		}
		break;
//////// Player ////////
	case EVENT_PlayerEntering:
		{
			Player *p = (Player*)event.p[0];
			PlayerTag *tag= new PlayerTag; //player enters, assign them a tag
			strcpy(tag->name,p->name); //set the tag's name
			taglist.append(tag); //place on taglist
		}
		break;
	case EVENT_PlayerMove:
		{
			Player *p = (Player*)event.p[0];
			
		if(Enabled) //if the bot is enabled
		{	
			_listnode <Obj> *parseObj = ObjLocations.head; // Holds All the obj locations
			PlayerTag *pt= ReturnTag(p); //grab the player's tag

			if (!CheckInside(pt)) //if player isnt inside obj area
			{
				unsigned short *NewArea; //new area they are inside
				while (parseObj) //Scroll through obj locations
				{
					if (p->tile.x > parseObj->item->x1 && p->tile.x < parseObj->item->x2 && p->tile.y > parseObj->item->y1 && p->tile.y < parseObj->item->y2)
					{ 	//check if they entered a obj area
						String S;//sends commands
						if(parseObj->item->Private) //used for private obj switching, ON or OFF
						{
							if(parseObj->item->On_Off) //they have entered area, turn on obj
							{
								S = "*objoff "; //object off command
							}
							else
							{
								S="*objon "; //object on command
							}
							S += parseObj->item->objNum; //add on object number
							sendPrivate(p,S.msg); //send command
						}
						else //used for normal obj switching, ON or OFF
						{
							if(!CheckAreaNumber(&parseObj->item->title)) //Is anyone already in the obj area??
							{  
								if(parseObj->item->On_Off) //No one in obj area, switch its state for new person
								{
									S = "*objoff "; //object off command
									parseObj->item->On_Off=false;
								}
								else
								{
									S="*objon "; //object on command
									parseObj->item->On_Off=true;
								}
								S += parseObj->item->objNum; //add on object number
								sendPublic(S.msg); //send command
							}

						}

						NewArea=new unsigned short; //allocate memory for new obj area
						NewArea= &parseObj->item->title;//assign a number to it
						pt->AreaNumber.append(NewArea); //place in areas player is in
					}

					parseObj = parseObj->next; //go to next positions in list
				}
			}
			else //if the player was inside obj area, see if they are still there
			{
				_listnode <unsigned short> *AreaNumber; //holds areanumbers of the player
				while (parseObj) //cycle through locations
				{
					AreaNumber=pt->AreaNumber.head;
					while(AreaNumber)
					{
						if(*AreaNumber->item == parseObj->item->title) //if the area the player is in and the ObjLocation match
						{
							if (!(p->tile.x > parseObj->item->x1 && p->tile.x < parseObj->item->x2 && p->tile.y > parseObj->item->y1 && p->tile.y < parseObj->item->y2))
							{ //if they left the obj area they were previously in
								RemoveInsidePerson(pt,AreaNumber->item);//remove them from inside of obj area list
							}
							break;
						}
						AreaNumber= AreaNumber->next;
					}
					parseObj = parseObj->next;//go to next positions in list
				}
	
			}
		}
		}
		break;
	case EVENT_PlayerWeapon:
		{
			Player *p = (Player*)event.p[0];
			weaponInfo wi;
			wi.n = *(Uint16*)&event.p[1];
		}
		break;
	case EVENT_WatchDamage:
		{
			Player *p = (Player*)event.p[0];	// player
			Player *k = (Player*)event.p[1];	// attacker
			weaponInfo wi;
			wi.n = *(Uint16*)&event.p[2];
			Uint16 energy = *(Uint16*)&event.p[3];
			Uint16 damage = *(Uint16*)&event.p[4];
		}
		break;
	case EVENT_PlayerDeath:
		{
			Player *p = (Player*)event.p[0],
				   *k = (Player*)event.p[1];
			Uint16 bounty = (Uint16)event.p[2];
		}
		break;
	case EVENT_PlayerScore:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_PlayerPrize:
		{
			Player *p = (Player*)event.p[0];
			int prize = *(int *)&event.p[1];
		}
		break;
	case EVENT_PlayerShip:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldship = (Uint16)event.p[1];
			Uint16 oldteam = (Uint16)event.p[2];
		}
		break;
	case EVENT_PlayerSpec:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldteam = (Uint16)event.p[1];
			Uint16 oldship = (Uint16)event.p[2];
			
			if(Enabled) //if bot is enabled
			{
				PlayerTag *pt= ReturnTag(p);//get the tag of the player that spec'd
				_listnode <unsigned short> *AreaNumber=pt->AreaNumber.head;//get that player's obj area locations
				while(AreaNumber)
				{
					RemoveInsidePerson(pt,AreaNumber->item);//remove them from areas
					AreaNumber= pt->AreaNumber.head;//need to bring AreaNumber back to head pointer, last command deleted it
				}
				pt->AreaNumber.clear();//make sure AreaNumber is clear and deallocated
			} //Spectating player's tags are reset
		}
		break;
	case EVENT_PlayerTeam:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldteam = (Uint16)event.p[1];
			Uint16 oldship = (Uint16)event.p[2];
		}
		break;
	case EVENT_PlayerLeaving:
		{
			Player *p = (Player*)event.p[0];

			if(Enabled)
			{
				PlayerTag *pt= ReturnTag(p); //grab player's tag
				_listnode <unsigned short> *AreaNumber=pt->AreaNumber.head; //grab player's obj area locations
				while(AreaNumber)
				{
					RemoveInsidePerson(pt,AreaNumber->item); //remove each obj location from tag
					AreaNumber= pt->AreaNumber.head;
				}
				pt->AreaNumber.clear();//make sure AreaNumber is clear and deallocated
				taglist.kill(pt); //delete player from taglist
			} //Leaving players tags deleted

		}
		break;
//////// Selfish ////////
	case EVENT_SelfShipReset:
		{
		}
		break;
	case EVENT_SelfPrize:
		{
			Uint16 prize = (Uint16)event.p[0];
			Uint16 count = (Uint16)event.p[1];
		}
		break;
	case EVENT_SelfUFO:
		{
		}
		break;
	case EVENT_PositionHook:
		{
		}
		break;
//////// Bricks ////////
	case EVENT_BrickDropped:
		{
			int x1 = *(int*)&event.p[0];
			int y1 = *(int*)&event.p[1];
			int x2 = *(int*)&event.p[2];
			int y2 = *(int*)&event.p[3];
			int team = *(int*)&event.p[4];
		}
		break;
//////// LVZ ////////
	case EVENT_ObjectToggled:
		{
			objectInfo obj;
			obj.n = (Uint16)event.p[0];
		}
		break;
//////// Turret ////////
	case EVENT_CreateTurret:
		{
			Player *turreter = (Player*)event.p[0];
			Player *turretee = (Player*)event.p[1];
		}
		break;
	case EVENT_DeleteTurret:
		{
			Player *turreter = (Player*)event.p[0];
			Player *turretee = (Player*)event.p[1];
		}
		break;
//////// Chat ////////
	case EVENT_Chat:
		{
			int type  = *(int*)&event.p[0];
			int sound = *(int*)&event.p[1];
			Player *p = (Player*)event.p[2];
			char *msg = (char*)event.p[3];

			switch (type)
			{
			case MSG_Arena:
				{
				}
				break;
			case MSG_PublicMacro:		if (!p) break;
				{
				}
				break;
			case MSG_Public:			if (!p) break;
				{
				}
				break;
			case MSG_Team:				if (!p) break;
				{
				}
				break;
			case MSG_TeamPrivate:		if (!p) break;
				{
				}
				break;
			case MSG_Private:			if (!p) break;
				{
				}
				break;
			case MSG_PlayerWarning:		if (!p) break;
				{
				}
				break;
			case MSG_RemotePrivate:
				{
				}
				break;
			case MSG_ServerError:
				{
				}
				break;
			case MSG_Channel:
				{
				}
				break;
			};
		}
		break;
	case EVENT_LocalCommand:
		{
			Player *p = (Player*)event.p[0];
			Command *c = (Command*)event.p[1];

			gotCommand(p, c);
		}
		break;
	case EVENT_LocalHelp:
		{
			Player *p = (Player*)event.p[0];
			Command *c = (Command*)event.p[1];

			gotHelp(p, c);
		}
		break;
	case EVENT_RemoteCommand:
		{
			char *p = (char*)event.p[0];
			Command *c = (Command*)event.p[1];
			Operator_Level o = *(Operator_Level*)&event.p[2];

			gotRemote(p, c, o);
		}
		break;
	case EVENT_RemoteHelp:
		{
			char *p = (char*)event.p[0];
			Command *c = (Command*)event.p[1];
			Operator_Level o = *(Operator_Level*)&event.p[2];

			gotRemoteHelp(p, c, o);
		}
		break;
//////// Containment ////////
	case EVENT_Init:
		{
			int major	= HIWORD(*(int*)&event.p[0]);
			int minor	= LOWORD(*(int*)&event.p[0]);
			callback	= (CALL_COMMAND)event.p[1];
			playerlist	= (CALL_PLIST)event.p[2];
			flaglist	= (CALL_FLIST)event.p[3];
			map			= (CALL_MAP)event.p[4];
			bricklist	= (CALL_BLIST)event.p[5];

			if (major > CORE_MAJOR_VERSION)
			{
				tell(makeEcho("DLL plugin cannot connect.  This plugin is out of date."));

				CONNECTION_DENIED = true;

				return;
			}
			else if ((major < CORE_MAJOR_VERSION) || (minor < CORE_MINOR_VERSION))
			{
				tell(makeEcho("DLL plugin cannot connect.  This plugin requires the latest version of MERVBot."));

				CONNECTION_DENIED = true;

				return;
			}
			else
				tell(makeEcho("DLL plugin connected."));
		}
		break;
	case EVENT_Term:
		{
			tell(makeEcho("DLL plugin disconnected."));
		}
		break;
	};
}


//////// DLL export ////////

_declspec(dllexport) void __stdcall talk(BotEvent &event)
{
	botInfo *bot;

	bot = findBot(event.handle);

	if (!bot)
	{
		bot = new botInfo(event.handle);
		botlist.append(bot);
	}

	if (bot) bot->gotEvent(event);
}


//////// Chatter ////////

void botInfo::sendPrivate(Player *player, BYTE snd, char *msg)
{
	tell(makeSay(MSG_Private, snd, player->ident, msg));
}

void botInfo::sendPrivate(Player *player, char *msg)
{
	tell(makeSay(MSG_Private, 0, player->ident, msg));
}

void botInfo::sendTeam(char *msg)
{
	tell(makeSay(MSG_Team, 0, 0, msg));
}

void botInfo::sendTeam(BYTE snd, char *msg)
{
	tell(makeSay(MSG_Team, snd, 0, msg));
}

void botInfo::sendTeamPrivate(Uint16 team, char *msg)
{
	tell(makeSay(MSG_TeamPrivate, 0, team, msg));
}

void botInfo::sendTeamPrivate(Uint16 team, BYTE snd, char *msg)
{
	tell(makeSay(MSG_TeamPrivate, snd, team, msg));
}

void botInfo::sendPublic(char *msg)
{
	tell(makeSay(MSG_Public, 0, 0, msg));
}

void botInfo::sendPublic(BYTE snd, char *msg)
{
	tell(makeSay(MSG_Public, snd, 0, msg));
}

void botInfo::sendPublicMacro(char *msg)
{
	tell(makeSay(MSG_PublicMacro, 0, 0, msg));
}

void botInfo::sendPublicMacro(BYTE snd, char *msg)
{
	tell(makeSay(MSG_PublicMacro, snd, 0, msg));
}

void botInfo::sendChannel(char *msg)
{
	tell(makeSay(MSG_Channel, 0, 0, msg));
}

void botInfo::sendRemotePrivate(char *msg)
{
	tell(makeSay(MSG_RemotePrivate, 0, 0, msg));
}

void botInfo::sendRemotePrivate(char *name, char *msg)
{
	String s;
	s += ":";
	s += name;
	s += ":";
	s += msg;

	sendRemotePrivate(s);
}
